#include <QDir>
#include <QString>
#include <QDebug>

#if QT_VERSION >= 0x050000
#include <QTemporaryDir>
#else
struct QTemporaryDir {
    bool isValid() { return true; }
    QString path() { return QDir().absolutePath(); }
};
#endif

static const char testDirC[] = "testdir";

int main(int, char**)
{
    QTemporaryDir parent;
    qDebug() << QT_VERSION_STR <<   parent.path();
    Q_ASSERT(parent.isValid());
    QString dirPath = parent.path() + QLatin1Char('/') + QLatin1String(testDirC);
    QDir dir(dirPath);
    if (dir.exists()) {
        qDebug() << "removing existing " << dirPath;
        QDir pd(parent.path());
        Q_ASSERT(pd.rmdir(testDirC));
    }
    Q_ASSERT(dir.mkpath(dirPath));
    qDebug() << "Created" << dirPath;
    // Note: First invocation on newly created directory returns "".
    qDebug() << "dir.canonicalPath()" << dir.canonicalPath();
    qDebug() << "dir.exists()" << dir.exists();
    qDebug() << "dir.canonicalPath()" << dir.canonicalPath();
    if (dir.exists()) {
        qDebug() << "Cleanup" << dirPath;
        QDir pd(parent.path());
        pd.rmdir(testDirC);
    }
    return 0;
}
